﻿using AccountContracts.BindingModels;
using AccountContracts.SearchModels;
using AccountContracts.StoragesContracts;
using AccountContracts.ViewModels;
using AccountDatabaseImplement.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AccountDatabaseImplement.Implements
{
    public class RoleStorage : IRoleStorage
    {
        public List<RoleViewModel> GetFullList()
        {
            using var context = new AccountDatabase();
            return context.Roles
                    .Select(x => x.GetViewModel)
                    .ToList();
        }

        public RoleViewModel? GetElement(RoleSearchModel model)
        {
            using var context = new AccountDatabase();
            return context.Roles
                    .FirstOrDefault(x => (model.Id.HasValue && x.Id == model.Id))
                    ?.GetViewModel;
        }

        public RoleViewModel? Insert(RoleBindingModel model)
        {
            var newRole = Role.Create(model);
            if (newRole == null)
            {
                return null;
            }
            using var context = new AccountDatabase();
            context.Roles.Add(newRole);
            context.SaveChanges();
            return newRole.GetViewModel;
        }

        public RoleViewModel? Update(RoleBindingModel model)
        {
            using var context = new AccountDatabase();
            var role = context.Roles.FirstOrDefault(x => x.Id == model.Id);
            if (role == null)
            {
                return null;
            }
            role.Update(model);
            context.SaveChanges();
            return role.GetViewModel;
        }

        public RoleViewModel? Delete(RoleBindingModel model)
        {
            using var context = new AccountDatabase();
            var element = context.Roles.FirstOrDefault(rec => rec.Id == model.Id);
            if (element != null)
            {
                context.Roles.Remove(element);
                context.SaveChanges();
                return element.GetViewModel;
            }
            return null;
        }

    }
}
