﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Reflection.Metadata;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Office.Interop.Word;
using static System.Net.Mime.MediaTypeNames;

namespace NevaevaLibrary.LogicalComponents
{
    public partial class WordLongTextComponent : Component
    {
        public WordLongTextComponent()
        {
            InitializeComponent();
        }

        public WordLongTextComponent(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        private object missing = System.Reflection.Missing.Value;

        public void createWithLongText(WordLongTextInfo wordInfo)
        {
            var winword = new Microsoft.Office.Interop.Word.Application();
            var document = winword.Documents.Add(ref missing, ref missing, ref missing, ref missing);
            document.PageSetup.RightMargin = 50;
            document.PageSetup.LeftMargin = 50;

            var header = document.Content.Paragraphs.Add(Type.Missing);
            header.Range.Text = wordInfo.header;
            header.Format.Alignment = WdParagraphAlignment.wdAlignParagraphCenter;
            header.Range.Font.Name = "Times New Roman";
            header.Range.Font.Size = 22;
            header.Range.Font.Bold = 2;
            header.Format.SpaceAfter = 18;
            header.Range.InsertParagraphAfter();

            foreach (string text in wordInfo.paragraphs)
            {
                var paragraph = document.Content.Paragraphs.Add(Type.Missing);
                paragraph.Range.Text = text;
                paragraph.Format.Alignment = WdParagraphAlignment.wdAlignParagraphLeft;
                paragraph.Range.Font.Name = "Times New Roman";
                paragraph.Range.Font.Size = 14;
                paragraph.Range.Font.Bold = 0;
                paragraph.Format.SpaceAfter = 18;
                paragraph.Range.InsertParagraphAfter();
            }

            document.SaveAs(wordInfo.path, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing);
            document.Close(ref missing, ref missing, ref missing);
            document = null;
            winword.Quit(ref missing, ref missing, ref missing);
        }
    }
}
